package nl.uvt.locator;

import java.io.File;

import nu.xom.*;

public class DocServer {
	long lastMod = 0;
	Document infoDoc = null;

	public Document refresh(ServeData sd) {
		Builder builder = new Builder();
		nu.xom.Document result = null;
		String propName = sd.base + "Info";
		Locator.logger.debug( "try to get property: " + propName );
		String docName = Locator.locatorConfig.getProperty( propName );
		if ( docName == null ){
			result = Locator.errorDoc("unable to find info about base: " + sd.base );
		}
		else 
			try {
				Locator.logger.debug( "try to get XML file: " + docName );
				File f = Locator.getFile( docName );
				if ( f  != null ){
					long moDate = f.lastModified();
					if ( moDate > lastMod ){
						Document fullDoc = builder.build( f );
						Locator.logger.debug( "new infoDocument:" + fullDoc.toXML() );
						if ( fullDoc != null ){
							infoDoc = fullDoc;
							lastMod = moDate;
						}				
					}
					else
						Locator.logger.debug( "unable to find document:" + docName );
				}
			} catch ( Exception e) {
				Locator.logger.error( "DocServer:", e );
			}		
			return result;
	}

	Document serverDoc( ServeData sd ){
		nu.xom.Document result = null;
		Nodes nodes = infoDoc.query( "//publisher[@id='"+sd.method +"']" );
		if ( nodes.size() == 0 )
			result = Locator.errorDoc( 0, "unknown method", sd.method );
		else {
			Nodes infoNodes = nodes.get(0).query("./info[@xml:lang='"+sd.language+"']");
			if ( infoNodes.size() == 0 ){
				infoNodes =  nodes.get(0).query("./info[@xml:lang='nl']");
				if ( infoNodes.size() == 0 )
					infoNodes =  nodes.get(0).query("./info");
			}
			if ( infoNodes.size() == 0 )
				result = Locator.errorDoc( "no info available" );
			else {
				// some trickery to avoid xml:lang in the output
				Element root = new Element("info");
				result = new Document( root );
				Text txt = new Text(infoNodes.get(0).getValue()); 
				root.appendChild( txt );
			}
		}
		return result;
	}


}
